<template>
  <transition :name="`${position}-modal`">
    <div
      v-if="modal.state.show"
      class="overflow-auto z-20 fixed inset-0 stacking cursor-auto select-auto text-base text-black"
      :class="{
        'items-center justify-items-center': isCenterPosition,
        'items-end justify-items-stretch': isBottomPosition
      }"
    >
      <div
        :class="
          `${
            !dimmed ? 'opacity-0' : isDynamicPosition ? 'opacity-25' : 'opacity-50'
          } h-full w-full bg-black z-20 cursor-pointer select-none dimmer`
        "
        @click.stop="modal.hide()"
      ></div>
      <div
        @click.stop=""
        ref="content"
        class="z-20 content"
        :class="{
          [contentClass]: true,
          rounded: isDynamicPosition && !raw,
          fixed: isDynamicPosition,
          'rounded-t-lg': isBottomPosition && !raw,
          'mt-32': isBottomPosition && !raw,
          'rounded-lg overflow-hidden': isCenterPosition && !raw,
          border: !dimmed,
          'bg-white shadow-lg ': !raw
        }"
        :style="positionedStyle"
      >
        <slot :modal="modal"></slot>
      </div>
    </div>
  </transition>
</template>

<script lang="ts">
import { Modal } from "..";
import { computed, ref, watchEffect } from "vue";
import responsive from "@/use/responsive";

export enum Position {
  Dynamic = "dynamic",
  Bottom = "bottom",
  Center = "center"
}

export default {
  props: {
    modal: {
      type: Modal,
      required: true
    },
    dimmed: {
      type: Boolean,
      default: false
    },
    raw: {
      type: Boolean,
      default: false
    },
    position: {
      type: String,
      default: Position.Dynamic
    },
    desktopPosition: {
      type: String,
      default: Position.Dynamic
    },
    contentClass: {
      type: String,
      default: ""
    }
  },
  beforeUnmount() {
    if (!this.modal.inlined) {
      this.modal.hide();
    }
  },
  setup(props, context) {
    const getPosition = (position: Position) => {
      if (position == Position.Dynamic) {
        if (props.modal.state.position.x != undefined || props.modal.state.position.y != undefined) {
          return position;
        }
      } else if (
        Object.keys(Position)
          .map(key => Position[key as keyof typeof Position])
          .includes(props.position)
      ) {
        return position;
      }

      return responsive.isDesktop ? Position.Center : Position.Bottom;
    };
    const position = computed(() => getPosition(responsive.isDesktop ? props.desktopPosition : props.position));
    const isDynamicPosition = computed(() => position.value == Position.Dynamic);
    const isBottomPosition = computed(() => position.value == Position.Bottom);
    const isCenterPosition = computed(() => position.value == Position.Center);

    const content = ref(null);

    const sizeRefresher = ref(0);
    const resizeObserver = new ResizeObserver(() => sizeRefresher.value++);

    watchEffect(() => {
      if (content.value) {
        resizeObserver.observe(content.value);
      }
    });
    let highestHeight = 0;
    let highestWidth = 0;
    const positionedStyle = computed(() => {
      sizeRefresher.value;
      if (content.value == null || !isDynamicPosition.value) {
        return {};
      }
      const elementdims = { width: 0, height: 0 };
      const element = window.$(content.value);
      if (element) {
        highestWidth = elementdims.width = Math.max(element.actual("width"), highestWidth);
        highestHeight = elementdims.height = Math.max(element.actual("height"), highestHeight);
      }
      const maxleft = responsive.width - elementdims.width - 5;
      const maxtop = responsive.height - elementdims.height - 5;
      const minleft = 5;
      const mintop = 5;

      return {
        position: "fixed",
        top: Math.max(Math.min(props.modal.state.position.y, maxtop), mintop) + "px",
        left: Math.max(Math.min(props.modal.state.position.x - elementdims.width / 2, maxleft), minleft) + "px",
        "max-width": "95%",
        "max-height": "95%"
      };
    });

    return {
      position,
      isDynamicPosition,
      isCenterPosition,
      isBottomPosition,
      content,
      positionedStyle
    };
  }
};
</script>

<style lang="stylus" scoped>
[class*="-modal-enter-active"]
  .content
    @apply ease-out
    transition opacity 45ms linear, transform 150ms
  .dimmer
    transition opacity 150ms linear
[class*="-modal-leave-active"]
  transition opacity 150ms linear
  .dimmer
    transition opacity 150ms linear
  .content
    transition opacity 150ms linear, transform 150ms linear

.bottom-modal-enter-from, .dynamic-modal-enter-from, .bottom-modal-leave-to
  .dimmer
    opacity 0
  .content
    transform: translateY(20%)
    opacity: 0

.center-modal-leave-to, .dynamic-modal-leave-to
  opacity 0

.center-modal-enter-from
  .dimmer
    opacity 0
  .content
    transform: scale(.8)
    opacity: 0
</style>
